#include <iostream>
#include <unistd.h>
#include "jcwepcrack.h" // library header file, has everything
#include "arguments.h"

#define DEBUG 1
//------------------------Important Global vars----------------
ArgumentsType GlobalArguments;
void usage();
void StartCracking(SessionData &data);
void parse_args(int argc, char **argv);

int main (int argc, char * argv[]) 
{
	parse_args(argc, argv);
	bool ret = false;
	SessionData data;
	while (1)
	{
		ret = StartNewSession(GlobalArguments.ServerName, GlobalArguments.port, data);
		if (!ret)
		{
			cout << "couldnt connect to server. \n";
			exit(0);
		}
		print_SessionData(data);
		StartCracking(data);	
		delete data.packet1_data;
		delete data.packet2_data;
		delete data.myKeySpaceChunk;

	}
	return 0;
}

void parse_args(int argc, char **argv)
{

	char ch;
	bool p_flag = false;
	bool s_flag = false;
	GlobalArguments.verbose = false;
	GlobalArguments.logging  = false;
	memset((void *) &GlobalArguments, 0, sizeof(GlobalArguments));

	while ((ch = getopt(argc, argv, "vl:p:s:")) != -1)
	switch (ch) 
	{
		case 'v': //verbose
			GlobalArguments.verbose = true;
		break;

		break;
		case 'p': //port
			p_flag = true;
			GlobalArguments.port = atoi(optarg);
			break;

		case 'l': // logfile
		GlobalArguments.logging = true;
		snprintf(GlobalArguments.LogFileName, sizeof(GlobalArguments.LogFileName), "%s", optarg);
		break;
		case 's':
		s_flag = true;
		snprintf(GlobalArguments.ServerName,sizeof(GlobalArguments.ServerName), "%s", optarg);
		break;

		case '?':
		default:
		{
			usage();
			exit(0);
		}
	}
	if (!p_flag)
		GlobalArguments.port = DEFAULT_PORT;
	else if (GlobalArguments.port <= 0)
	{
		fprintf(stderr, "Invalid Port. %d\n", GlobalArguments.port);
		usage();
		exit(0);
	}

	if (!s_flag)
	{
		fprintf(stderr, "Need to specify a server\n");
		usage();
		exit(0);
	}

	
}

void StartCracking(SessionData &session_data)
{
	bool success_decrypt = false;
	bool success_verify = false;
	
	Key k = (*session_data.myKeySpaceChunk).iKey;
	
	/*
	k.value[0] = 0x00;
	k.value[1] = 0x11;
	k.value[2] = 0x22;
	k.value[3] = 0x33;
	k.value[4] = 0x30;
*/
	cout << "Attempting to crack a " << k.getSize()<< "byte key\n";

	u_int32_t high = (*session_data.myKeySpaceChunk).range;
	for (int i = 0; i <= high; i++)
	{
		success_decrypt = DecryptWepData(session_data.packet1_data, session_data.packet1size, session_data.packet1_iv,
					      k.value, k.getSize());
		if (success_decrypt) // double check /w another packet
		{
		success_verify = DecryptWepData(session_data.packet2_data, session_data.packet2size, session_data.packet2_iv,
					      k.value, k.getSize());
		}

		if(success_verify)
		{
			printf("Success.\n");
			printf("Key:\t");	
			cout << k << endl;
			printf("Original Key:\t");
			cout << (*session_data.myKeySpaceChunk).iKey << endl;

			SubmitVerifiedKey(GlobalArguments.ServerName, GlobalArguments.port,
				   	(*session_data.myKeySpaceChunk).session_id, k);
			exit(0);
		}
		//cout << "fail: " << k << endl;
//		cout << "fail: " << (*session_data.myKeySpaceChunk).iKey;
		k++;
		i++;
	}	
	// Report KeySpaceChunk Empty;
	SubmitFinishedKeySpaceChunk(GlobalArguments.ServerName, GlobalArguments.port,
				   	(*session_data.myKeySpaceChunk).session_id, (*session_data.myKeySpaceChunk).iKey);

}
	

void usage()
{
	printf("jc-wepcrack-client by Johnny Cache. A nologin production\n");
	printf("./jc-wepcrack [ -v (verbose) -l logfilename  -p port] -s server\n");
}
