/*
 *  Misc.cpp
 *  jc-wepcrack
 *
 *  Created by johnny cache on Sun Jul 11 2004.
 *  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
 *
 */

#include "datatypes.h"
#include "misc.h"
#include "packet.h"
#include "packet80211.h"
#include <pcap.h>
#include <stdlib.h>
#include <map.h>
#include "arguments.h"
extern Packet_80211 *GlobalPacketToCrack;
extern ArgumentsType GlobalArguments;
//extern u_int8_t *GlobalArguments.BssIdToCrack;

void print_hex(u_char_t *start, u_int32_t len)
{
	u_int32_t cnt = 0;
	int char_cnt = 0;
	int grp_cnt = 0;
	while (cnt < len)
	{
		printf("%2.2x ", *(start + cnt));
		grp_cnt++;
		char_cnt++;
		cnt++;
		if (grp_cnt == 8) 
		{
			printf(" : ");
			grp_cnt = 0;
		}
			if (char_cnt == 32)
		{
			printf("\n");
			char_cnt = 0;
		}
	}
	printf("\n");
}
void getBssIdToCrack(char *filename)
{
    
	map<int, Packet_80211*> BssIdMap;
	map<int, Packet_80211*>::iterator myIter;
	
	int             count = 0;
	int 			listcnt = 1;
	u_int8_t tmpbssid[6];
	char            errbuf[PCAP_ERRBUF_SIZE];
	u_char         *pkt;
	struct pcap_pkthdr h;
	int dlt; // data link type
	pcap_t *p;
	u_int8_t currBssId[6];
	Packet_80211 *currPacket;

	if ((p = pcap_open_offline(filename, errbuf)) == NULL) {
		fprintf(stderr, "error: unable to open pcap output file: %s\n", errbuf);
		exit(2);
	}
	dlt = pcap_datalink(p);
	// If we were so inclined we could also handle the prism datalink type. It is just
	// this with debuginfo prepended.
	if (dlt != DLT_IEEE802_11)
	{
			printf("Error. Unsupported link type detected\n");
			exit(0);
	}

	while (1) 
	{
		if ((pkt = (u_char *) pcap_next(p, &h)) == NULL)
		{
			// no more packets.
			break;
		}
		count++;
		currPacket = new Packet_80211(h, pkt); // isnt that pretty? 
		if ( !currPacket->isWep())
		{
			delete currPacket;
			//cout << "skipping packet # " << count << "because its not WEP\n";
			continue;
		}
		currPacket->getBssId(currBssId);

		bool addtolist = true;
		myIter = BssIdMap.begin();
		
		while (myIter != BssIdMap.end())
		{
			u_int8_t tmpbssid[6];
			(myIter->second)->getBssId(tmpbssid);

			//dont add dupe bssids to the list
			if (memcmp((void *) &tmpbssid, (void*) &currBssId, sizeof(currBssId)) == 0)
				{
					addtolist=false;
				}

			myIter++;
		}

		if (addtolist)
		{
			BssIdMap[listcnt] = currPacket;
			listcnt++;
		}
		else
			delete currPacket;

		
	}
	
	if (BssIdMap.size() == 0)
	{
		fprintf(stderr, "No Encrypted wireless packets found. wtf d00d?. check your input\n");
		exit(0);
	}
	else if (BssIdMap.size() == 1)
	{
			memcpy(&GlobalArguments.BssIdToCrack, &currBssId, sizeof(currBssId));
	}
	else
	{
		myIter = BssIdMap.begin();
		int cnt = 0;
		int selected = -1;
		printf("---------------------------------------------------------\n");
		printf("Please choose the bssid of the network you wish to crack:\n");
		printf("---------------------------------------------------------\n");

		printf("Available networks to crack:\n");
		while (myIter != BssIdMap.end())
		{
			(myIter->second)->getBssId(tmpbssid);
			printf("%d)\t", (myIter->first));
			print_hex((u_char_t*) &tmpbssid, sizeof(tmpbssid));
			myIter++;
			cnt++;
		}
		while (selected <= 0 || selected > cnt)
		{
			cout << "please select the bssid of the network to crack.\n";
			scanf("%d", &selected);
		}
			BssIdMap[selected]->getBssId(tmpbssid);
			//cout << "cracking network : " ;
			//print_hex((u_char_t*) &tmpbssid, sizeof(tmpbssid));	
			memcpy(&GlobalArguments.BssIdToCrack, &tmpbssid, sizeof(tmpbssid));
	}
			
		myIter = BssIdMap.begin();
		while (myIter != BssIdMap.end())
		{
			delete	myIter->second;
			myIter++;
		}

}

Packet_80211* getverifypkt(char *filename)
{
    
	int             count = 0;
	char            errbuf[PCAP_ERRBUF_SIZE];
	u_char         *pkt;
	struct pcap_pkthdr h;
	int dlt; // data link type
	pcap_t *p;

	if (GlobalPacketToCrack == NULL)
	{
			perror("Dont call getverifypacket before setting GlobalPacketToCrack\n");
			exit(0);
	}
	if ((p = pcap_open_offline(filename, errbuf)) == NULL) {
		fprintf(stderr, "error: unable to open pcap output file: %s\n", errbuf);
		exit(2);
	}
	dlt = pcap_datalink(p);
	// If we were so inclined we could also handle the prism datalink type. It is just
	// this with debuginfo prepended.
	if (dlt != DLT_IEEE802_11)
	{
			printf("Error. Unsupported link type detected\n");
			exit(0);
	}
	
	Packet_80211 *currPacket = NULL;
	while (1) 
	{
		if ((pkt = (u_char *) pcap_next(p, &h)) == NULL)
		{
			break;
		}
		count++;
		currPacket = new Packet_80211(h, pkt); // isnt that pretty? 

		//used to check for isNormal but now i dont think we need it
		if (!currPacket->isWep())
		{
			delete currPacket;
			continue;
		}
		u_int8_t tmpbssid[6];
		currPacket->getBssId(tmpbssid);
		if (memcmp(&tmpbssid, &GlobalArguments.BssIdToCrack, sizeof(tmpbssid)) != 0) //not the droid we're looking for
		{
			delete currPacket;
			continue;
		}

		// if (this packets != packet to crack)
		if (memcmp( &(currPacket->pcap_hdr), &(GlobalPacketToCrack->pcap_hdr), 
					sizeof(struct pcap_pkthdr)) != 0)
			break;
		else
			delete currPacket;
	}

	if (currPacket == NULL)
	{
		fprintf(stderr, "Couldnt find a verify packet. \n");
		exit(0);
	}

	printf("Using Packet %d to verify\n",count);
	//printf("Size: %d\n", currPacket->length);
	//currPacket->print();	

	return currPacket;
}
Packet_80211* getsmallpkt(char *filename)
{
    
	int             count = 0;
	int 			smallPacketNumber = 0;
	char            errbuf[PCAP_ERRBUF_SIZE];
	u_char         *pkt;
	struct pcap_pkthdr h;
	Packet_80211 *smallPacket;
	int dlt; // data link type
	pcap_t *p;

	if ((p = pcap_open_offline(filename, errbuf)) == NULL) {
		fprintf(stderr, "error: unable to open pcap output file: %s\n", errbuf);
		exit(2);
	}
	dlt = pcap_datalink(p);
	// If we were so inclined we could also handle the prism datalink type. It is just
	// this with debuginfo prepended.
	if (dlt != DLT_IEEE802_11)
	{
			printf("Error. Unsupported link type detected\n");
			exit(0);
	}
	
	smallPacket = NULL;
	// Really what i should do is  have whole seperate function to go through the input file
	// and make sure its sane. Check that theres not more then 1 network, etc
	while (1) 
	{
		if ((pkt = (u_char *) pcap_next(p, &h)) == NULL)
		{
			break;
		}
		count++;
		Packet_80211 *currPacket = new Packet_80211(h, pkt); // isnt that pretty? 

		if ( !currPacket->isWep())
		{
			delete currPacket;
		//	cout << "skipping packet # " << count << "because its not WEP\n";
			continue;
		}
		u_int8_t tmpbssid[6];
		currPacket->getBssId(tmpbssid);
		if (memcmp(&tmpbssid, &GlobalArguments.BssIdToCrack, sizeof(tmpbssid)) != 0) //not the droid we're looking for
		{
			//print_hex((u_int8_t *) &tmpbssid, sizeof(tmpbssid));
			//print_hex((u_int8_t*) &GlobalArguments.BssIdToCrack, sizeof(tmpbssid));
			delete currPacket;
			continue;
		}
		
		if (smallPacket == NULL) 
		{
				smallPacket = currPacket;
				smallPacketNumber = count;
		}
		else if (smallPacket->length > currPacket->length)
		{
				delete smallPacket;
				smallPacket = currPacket;
				smallPacketNumber = count;
		}
		
	}

	if (smallPacket == NULL)
	{
		fprintf(stderr, "No Encrypted wireless packets found. wtf d00d?. check your input\n");
		exit(0);
	}

	printf("Using Packet %d  to crack\n", smallPacketNumber);
	//printf("Size: %d\n", smallPacket->length);
	//printf("Wep: %d\n", smallPacket->isWep());
	//printf("Normal: %d\n", smallPacket->isNormal());

	//smallPacket->print();	

	return smallPacket;
}


