#ifndef _DATATYPES_H
#define _DATATYPES_H
#include "typedefs.h"
 //apparently theres more then one format that cards use. This is the generic
 //one you would expect without any extra debug info (ala prism)
// This is not as straight forward as it seems. Based on some values in
// frame_ctrl, the addresses may either be ordered: 
// bss, source dest (0x41**) or
// dest, bss, source (0x02**) (0x4208) 0x0A08)
// 0x0a08 == udp
struct DLT_IEEE802_11_frame
{
	u_int16_t frame_ctrl;
	u_int16_t duration;
	// it is very tempting to label these as below but it is logically incorrect
	// the addresses swtich position based on the flags.
	u_int8_t addr1[6];
	u_int8_t addr2[6];
	u_int8_t addr3[6];
	
	/*
	u_int8_t dest_addr[6]; //THESE MOVE! see above.
	u_int8_t bssid[6];
	u_int8_t source_addr[6];
	*/
	u_int16_t seqfragno; // Actuall this is the seq & frag #.
};

/*
 *   all data packets have a snap (sub-network access protocol) header that
 *  * isn't entirely definied, but added for ethernet compatibility.
 *  
 */
struct wi_snap_frame 
{
    u_int16_t   wi_dat[3];
    u_int16_t   wi_type;
};

typedef struct
{
	u_int32_t size;
	u_char_t *data;
} serialized_object;

//typedef struct_serialized_object_type serialized_object;
#endif

