#ifndef _PACKET80211_H
#define _PACKET80211_H

#include "datatypes.h"
#include "packet.h"
#include <pcap.h>

class Packet_80211: public Packet
{
	private:
	struct DLT_IEEE802_11_frame wlan_header;
		

	public:
	Packet_80211(struct pcap_pkthdr p, u_char_t *data);
	int getDataLength();
	void getData(u_char_t *d);
	void print();
	void print(ostream& s);
	bool isEntering(); //toward AP
	bool isExiting(); //away from AP
	bool isWep();
	//	i used to think it was necessary to filter on the type field for null functions etc
	//	it now looks like anything that has the wep bit set has a valid payload.
	//	this will remain unimplemented until then
//	bool isNormal(); // normal data, no null functions, etc.
	void getSrcAddr(u_int8_t* dest);
	void getDstAddr(u_int8_t* dest);
	void getBssId(u_int8_t * dest);
	bool getWepIV(u_int8_t * dest);
	bool getWepKeyNum(u_int8_t *dest);
	bool getWepICV(u_int8_t * dest);
	
	
	bool wepEnabled();
};
#endif

