#include "decrypt.h"
#include "datatypes.h"
#include "print.h"
#include <string.h> // memcpy
#include <stdio.h>
#include <iostream.h>
bool DecryptWepData(u_int8_t *encrypted_data, u_int32_t encr_size, u_int8_t *iv, u_int8_t *key, u_int32_t key_size)
{
	RC4_KEY rc4key;
	u_int8_t *decrypted_icv; // decrpyted checksum
	u_int32_t decrypted_icv_crc;	
	u_int32_t computed_crc;

	u_int8_t *prng_seed = new u_int8_t[key_size + 3];
	u_int8_t *decrypted_data = new u_int8_t[encr_size];
	memcpy(prng_seed , iv, 3);
	memcpy(prng_seed + 3, key, key_size);
	
	// here we seed the rc4 prng with the iv + the secret key
/*
	printf("Seeding prng with: ");
	print_hex(prng_seed, key_size + 3);
	printf("\n");
	
	printf ("Encrypted data:\n");
	print_hex(encrypted_data, encr_size);
	printf("\n\n");	

	printf("================Decrypted Data==============\n");
*/
	//give it a shot
//	print_hex(key, key_size);
	//printf("\n");

	RC4_set_key(&rc4key, key_size + 3, prng_seed);
	//RC4(key, length, indata, outdata)
	RC4(&rc4key, encr_size, encrypted_data, decrypted_data);
//	print_hex(decrypted_data, encr_size);

	// print out our decrpyted icv:
	decrypted_icv = decrypted_data +encr_size - 4;
	decrypted_icv_crc = decrypted_icv[0] | (decrypted_icv[1] << 8) 
				       | (decrypted_icv[2] << 16) | (decrypted_icv[3] << 24);
	
//	printf("Decrypted icv: ");
//	print_hex(decrypted_icv, 4);
//	printf("crc of Decrypted icv: %x\n", decrypted_icv_crc);
//	printf("\n");
	
	
	//	Now compute the icv of our decrypted packet and check to see if it matches

	computed_crc = bufcrc(decrypted_data, encr_size - 4); // dont forget to not crc the ivc at the end
//	printf("computed crc of data: %x\n", computed_crc);
//	printf("\n");

	delete prng_seed;
	delete decrypted_data;
	if (computed_crc == decrypted_icv_crc)
	{
			printf("we found a match!\n");
			return true;
	}
	return	false; 
	
	
}



u_int32_t bufcrc(u_int8_t *buf, int size)
{
	//XXX: used to be u_int, how did that work?
	register u_int32_t val;
	val = ~0;
	while(size--)
	{
		val = crc_table[(val ^ *buf) & 0xff] ^ (val >> 8);
		buf++;
	}
	return ~val;

}


