/*
 *  Key.cpp
 *  jc-wepcrack
 *
 *  Created by johnny cache on Sun Jul 11 2004.
 *  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
 *
 */
#include <iostream.h>
#include <stdio.h>
#include "key.h"

Key::Key(int _size, unsigned char _max) 
{
    size =_size;
    MAXCHAR = _max;
    if (size <= 1)
     {
		//throw Exception;
		cout << "Keys cant be <= 1 byte\n";
		exit(0);
		//value = NULL;
	return;
     }
	if (size > MAX_KEY_SIZE_IN_BYTES)
	{
		fprintf(stderr, "Key size to big. MAX_KEY_SIZE_IN_BYTES = %d\n", MAX_KEY_SIZE_IN_BYTES);
		exit(0);
	}	

    memset(value, 0, sizeof(value));
}

bool Key:: operator == (const Key &right)
{
#ifdef JC_DEBFG
	cout << "comparing myself to " << right << endl;
#endif
	if ( size != right.size)
	{
//		fprintf(stderr, "DONT COMPARE KEYS OF DIFFERENT SIZES TOGETHER\n");
		return false;
	}
	if (memcmp(value, right.value, size) == 0)
		return true;
	else
		return false;	
}

Key& Key:: operator = (const Key &right)
{
	#ifdef JC_DEBUG
	cout << "Key assign operator\n";
	#endif
	this->size = right.size;
	this->MAXCHAR = right.MAXCHAR;

	memcpy(this->value, right.value, right.size);
	return *this;
}

bool Key:: operator < (const Key &right) const //WTF is this const doing?
{
	int rc;

	#ifdef JC_DEBUG
	cout << "comparing myself" <<  (*this) << "to " << right << endl;
	#endif
	if ( size != right.size)
	{
		fprintf(stderr, "DONT COMPARE KEYS OF DIFFERENT SIZES TOGETHER\n");
		return false;
	}

	 rc = memcmp(value, right.value, size);
	 if (rc < 0)
		return true;
	else
		return false;	
}

void Key:: operator ++ (int i)
{
	if (i < 0)
		return;
    // first find the byte we can increment;
    int curr_offset = size -1; // work from the right hand side.
    // the math signs can get confusing, Remember we are counting from the right.
    while (value[curr_offset] == MAXCHAR && curr_offset > 0)
	curr_offset--;
    
    if (curr_offset == size - 1) // most likely case.
       {
	    value[curr_offset]++;
	    return;
       }
    if (curr_offset == 0)
       {
	//cout << "Eek. were at the end of the key.\n";
	if (value[curr_offset] != MAXCHAR)
	   {
	    //cout << "But were still OK\n";
	    value[curr_offset]++;
	    //zero all the other bytes.
	    for (int i = 1; i < size; i++)
		value[i] = 0;
	   }
	else
	   {
	   // cout << "And were out of bytes!\n";
	   // cant add anymore.
	    }
	return;
       } // curr_offset = 0; (working on most significant byte)
 
     else if(curr_offset != 0)
	{
	// cout << "General Case\n";
	 if (value[curr_offset] == MAXCHAR)
	    {
	     cout << "Key:: operator ++ :: sanity check failed!\n";
	     exit(0);
	    }
	 value[curr_offset]++;
	 //zero all the other bytes.
	 for (int i = curr_offset + 1; i < size; i++)
	     value[i] = 0;
	 
	}
}

void Key:: operator += (int in)
{
	for(int i = 0; i < in; i++)
		this->operator ++(0);// the 0 is just because it expects a int. 
}
			

Key::~Key()
{
		int i;
#ifdef JC_DEBUG
	cout << "Key::" << *this << "~Key\n";
#endif
	i++;
}



serialized_object Key :: serialize ()
{

	u_int32_t mysize = 0;
	u_int32_t n_size; // network_size;
	serialized_object ser_key;

	mysize = sizeof(size) + sizeof(MAXCHAR) + size;
	u_char_t *p = new u_char_t[mysize];
	
	if(p == NULL)
	{
		cout << "Could not allocate memory in Key::serialize. exiting\n";
		exit(0);
	}
	//printf("t ix %x\n, allocated memory at %x\n", t, *t);
	ser_key.data = p;

	n_size = htonl(size);
	memcpy(p, (void *) &n_size, sizeof(n_size));
	p += sizeof(size);
	memcpy(p, (void *) &MAXCHAR, sizeof(MAXCHAR));
	p += sizeof(MAXCHAR);
	memcpy(p, value, size); // this is different
	
	ser_key.size = mysize;
	
	return ser_key;

}

Key unserializeKey(serialized_object object)
{
	u_char_t *p;

	u_int32_t k_size;
	u_char_t k_maxchar;
	
	Key default_key;
	p = object.data;
	memcpy( (void *) &k_size, p, sizeof(k_size));
	k_size = ntohl(k_size);
	
	if (k_size > MAX_KEY_SIZE_IN_BYTES)
		return default_key; //if i did this right id throw something

	p += sizeof(k_size);
	memcpy( (void *) &k_maxchar, p, sizeof(k_maxchar));
	p += sizeof(k_maxchar);

	Key k(k_size, k_maxchar);
	memcpy(k.value, p, k_size); // different
	return k;
}

u_int32_t Key :: serialize (FILE *fp)
{

	u_int32_t mysize = 0;
	int rc;
	mysize = sizeof(size) + sizeof(MAXCHAR) + size;

	fwrite( (void *) &size, sizeof(size), 1, fp);
	fwrite( (void *) &MAXCHAR, sizeof(MAXCHAR), 1, fp);
	fwrite( (void *) value, size, 1, fp); // diffferent
	if (ferror(fp))
		{
			cout << "fatal error in Key::serialize. fwrite failed.\n";
			perror("fwrite:");
			exit(0);
		}
#ifdef JC_DEBUG
	printf("wrote key in %d bytes\n", mysize);
#endif
	return mysize;
}
// nor this

Key unserializeKey(FILE *fp)
{
	u_int32_t k_size;
	u_char_t k_maxchar;
	int rc; 
	u_int32_t read_size = 0;

	fread( (void *) &k_size, sizeof(k_size), 1, fp);
	fread( (void *) &k_maxchar, sizeof(k_maxchar), 1, fp);
	if (ferror(fp))
		{
			cout << "fatal error in unserialize key. fread failed.\n";
			perror("fread:");
			exit(0);
		}
	read_size += sizeof(k_size) + sizeof(k_maxchar);
#ifdef JC_DEBUG
	printf("unserializing a key with size %d and maxchar %x\n", k_size, k_maxchar);
#endif
	Key k(k_size, k_maxchar);

	rc = fread( (void *) k.value, k_size, 1, fp); // diffferent
	if (ferror(fp))
		{
			cout << "fatal error in unserialize key. fread failed.\n";
			perror("fread:");
			exit(0);
		}
	if (rc != 1)
		printf("Error reading key. didnt finish\n");
	else
	read_size += k_size;
#ifdef JC_DEBUG
	printf("Read in %d bytes to unserialize key \n", read_size);
#endif
	return k;
}
string Key::getString()
{
	string s;
	string t;
    char tmp[256]; 
    int i;
    for ( i = 0; i < size; i++)
       {
		snprintf(tmp,sizeof(tmp), "%2.2x:", value[i]);
		t = tmp;
		s = s + t;
	   }
	return s;

}

// This is not part of the class, it is a friend
//ostream &operator<<(ostream &o, const Key &k)
ostream &operator<<(ostream &o, const Key &k)
{
	//o << k.getString();
	string s;
	string t;
    char tmp[256]; 
    int i;
    for ( i = 0; i < k.size; i++)
       {
		snprintf(tmp,sizeof(tmp), "%2.2x:", k.value[i]);
		t = tmp;
		s = s + t;
	   }
	o << s;
	return o;

}

