#include "packet.h"

Packet :: Packet(struct pcap_pkthdr h, u_char_t * d)
{
	initialized = 0;
	if (!d)
		{
			fprintf(stderr, "dont initalize packets /w null pointers!\n");
			return;
		}
	pcap_hdr = h;
	length = h.len; // as opposed to h.caplen? Not sure which i should use.
	data = new u_char_t[length];
	if (!data)
	{
			fprintf(stderr, "Could not allocate mem for packet. Dieing.\n");
			exit(-1);
	}
	memcpy(data, d, length); //get our own copy.
	initialized = 1;

}

void Packet :: print_hex_dump()
{
		print_hex_dump(cout);
}

void Packet :: print_hex_dump(ostream &s)
{
		print(s);
}
		
void Packet :: print()
{
		print(cout);
}
void Packet :: print(ostream & s)
{
	char tmp[256];

	u_int32_t cnt = 0;
	int grp_cnt = 0;
	int line_cnt = 0;
	
	if (!initialized)
	{
			fprintf(stderr, "Cannot print unitiialized packet\n");
			return;
	}

	while (cnt < length)
	{
		unsigned char c = data[cnt];
		//if (c < 9)
		//	s << "0";
		snprintf(tmp,sizeof(tmp), "%2.2x ",  c);
		s << tmp;
		
		cnt++;
		grp_cnt++;
		line_cnt++;
		if (grp_cnt == 8)
		{
			grp_cnt = 0;
			s  << " : ";
			//	snprintf(line, sizeof(line), " ");
		}
		if (line_cnt == 32)
		{
			//	snprintf(line,sizeof(line),  "\n");
			//	s << line;
				s << endl;
				line_cnt = 0;
		}
	
		
	}
}
Packet::~Packet()
{
//	cout << "Deallocating packet\n";
	delete data;
}
